/* Simu.java -	(c) Ilpo Jrvinen
 *
 * TiTo K2000 Harj.
 */


import java.io.*;		// File, BufferedReader


public class Simu {

	public static Cpu cpu = new Cpu();
	
	public int	readDump( String fname )
	{
		for (int i = 0; i < Cpu.MEMSIZE; i++)
			cpu.tomem( i, null );
		
		try {
			BufferedReader r = new BufferedReader( new FileReader( new File( fname ) ) );
			String s;
			int	last = 0;
			while ((s = r.readLine()) != null) {
//				System.out.println( s );
				String t = s.substring(s.indexOf(':')+1).trim();
				int temp = Integer.parseInt(t.substring(0,t.indexOf(' ')).trim());
//				System.out.println( temp );
				cpu.tomem( last++, new Instruction( temp ));
			}
			return last;
		} catch (Exception e) {
			System.out.println( "Invalid file" );
			return 0;
		}
	}


	public void dump()
	{
		System.out.print( cpu.dump() );
		System.out.print( cpu.memdump() );
	}

	public static void main( String args[] )
	{
		Simu x = new Simu();
		int lastaddr = x.readDump( args[ 0 ] );
		if (lastaddr == 0)
			return;
		cpu.reset( lastaddr, 0, Cpu.MEMSIZE );
		x.dump();
		x.cpu.exec( true );
	}
}
